document.addEventListener('DOMContentLoaded', () => {
  const canvas = document.getElementById('memeCanvas');
  const ctx = canvas.getContext('2d');
  let img;

  function drawMeme() {
    if (!img) return;
    
    canvas.width = img.width;
    canvas.height = img.height;
    ctx.drawImage(img, 0, 0);
    
    // Text styling
    ctx.fillStyle = 'white';
    ctx.strokeStyle = 'black';
    ctx.lineWidth = 2;
    ctx.textAlign = 'center';
    ctx.font = '40px Impact';

    // Top text
    ctx.textBaseline = 'top';
    ctx.strokeText(document.getElementById('topText').value, canvas.width/2, 10);
    ctx.fillText(document.getElementById('topText').value, canvas.width/2, 10);

    // Bottom text
    ctx.textBaseline = 'bottom';
    ctx.strokeText(document.getElementById('bottomText').value, canvas.width/2, canvas.height - 10);
    ctx.fillText(document.getElementById('bottomText').value, canvas.width/2, canvas.height - 10);
  }

  document.getElementById('memeImage').addEventListener('change', function(e) {
    const reader = new FileReader();
    reader.onload = function(event) {
      img = new Image();
      img.onload = () => drawMeme();
      img.src = event.target.result;
    }
    reader.readAsDataURL(e.target.files[0]);
  });

  document.getElementById('topText').addEventListener('input', drawMeme);
  document.getElementById('bottomText').addEventListener('input', drawMeme);

  document.getElementById('downloadBtn').addEventListener('click', function() {
    const link = document.createElement('a');
    link.download = 'meme.png';
    link.href = canvas.toDataURL();
    link.click();
  });
});